# Uses of Class
net.shibboleth.idp.attribute.IdPAttribute

Packages that use IdPAttribute
Package
Description
net.shibboleth.idp.attribute
`IdPAttribute`s are protocol-agnostic units of information about some thing, usually a user.
net.shibboleth.idp.attribute.config
Configuration support for leveraging `IdPAttribute` objects decoded from SAML metadata for access to settings.
net.shibboleth.idp.attribute.context
Context to do with Attribute Manipulation.
net.shibboleth.idp.attribute.filter
This package contains a filtering engine for a collection of `IdPAttribute`s.
net.shibboleth.idp.attribute.filter.context
The contexts to do with attribute filtering.
net.shibboleth.idp.attribute.filter.matcher.impl
Implementation of the various policy matchers.
net.shibboleth.idp.attribute.filter.matcher.logic.impl
Implementation of the logical attribute matchers.
net.shibboleth.idp.attribute.filter.matcher.saml.impl
This is where the attribute matchers that understand SAML live.
net.shibboleth.idp.attribute.filter.policyrule.saml.impl
This is where the attribute policy rules that understand SAML live.
net.shibboleth.idp.attribute.filter.testing
Testing utility classes.
net.shibboleth.idp.attribute.resolver
A system which is capable of retrieving a collection of `IdPAttribute`s from a variety of locations, transform them, and associate a set of protocol-specific encoders to them.
net.shibboleth.idp.attribute.resolver.ad.impl
Implementations of various `AttributeDefinition`s.
net.shibboleth.idp.attribute.resolver.ad.mapped.impl
A `DataConnector` implementation that maps from a given set of source value to an output value.
net.shibboleth.idp.attribute.resolver.context
The context to do with Attribute Resolution.
net.shibboleth.idp.attribute.resolver.dc
Interfaces supporting data connectors.
net.shibboleth.idp.attribute.resolver.dc.http
Package for HTTP data connector configuration.
net.shibboleth.idp.attribute.resolver.dc.http.impl
A `DataConnector` implementation that reads data from an HTTP web service.
net.shibboleth.idp.attribute.resolver.dc.impl
Common functionality used by data connectors.
net.shibboleth.idp.attribute.resolver.dc.impl.testing
Testing utility classes.
net.shibboleth.idp.attribute.resolver.dc.ldap
Package for LDAP data connector configuration.
net.shibboleth.idp.attribute.resolver.dc.ldap.impl
A `DataConnector` implementation that reads data from an LDAP.
net.shibboleth.idp.attribute.resolver.dc.rdbms
Package for RDBMS data connector configuration.
net.shibboleth.idp.attribute.resolver.dc.rdbms.impl
A `DataConnector` implementation that reads data from a relational database.
net.shibboleth.idp.attribute.resolver.dc.saml.impl
A `DataConnector` implementation that queries data from a SAML attribute authority.
net.shibboleth.idp.attribute.resolver.dc.scripted.impl
Classes which make up the scripted data connector.
net.shibboleth.idp.attribute.resolver.dc.storage.impl
Implementation of StorageService-backed data connector.
net.shibboleth.idp.attribute.resolver.impl
Implementations of core resolver functionality.
net.shibboleth.idp.attribute.resolver.scripted
This Package contains interface definitions exported to ECMAScript.
net.shibboleth.idp.attribute.resolver.spring.dc.impl
Implementation of specific DataConnector parsers.
net.shibboleth.idp.attribute.resolver.testing
Testing utility classes.
net.shibboleth.idp.attribute.transcoding
APIs for transcoding of attributes.
net.shibboleth.idp.attribute.transcoding.impl
Implementation classes for attribute transcoding.
net.shibboleth.idp.saml.attribute.impl
Miscellaneous implementation classes related to SAML Attributes.
net.shibboleth.idp.saml.attribute.resolver.impl
Implementations of SAML related `AttributeDefinition` and `DataConnector`.
net.shibboleth.idp.saml.attribute.transcoding
Base classes for SAML `AttributeTranscoder` classes.
net.shibboleth.idp.saml.attribute.transcoding.impl
Implementations of SAML transcoders.
net.shibboleth.idp.saml.saml2.nameid.transcoding
API classes for SAML 2.0 NameID decoding classes.
net.shibboleth.idp.saml.saml2.nameid.transcoding.impl
SAML 2.0 NameID transcoder implementations.

## Uses of IdPAttribute in net.shibboleth.idp.attribute

Subclasses of IdPAttribute in net.shibboleth.idp.attribute
Modifier and Type
Class
Description
`final class`
`IdPRequestedAttribute`
IdP representation of `RequestedAttribute`.
Fields in net.shibboleth.idp.attribute with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private final Multimap<String,IdPAttribute>`
AttributesMapContainer.`providedValue`
The map we are encapsulating.
Methods in net.shibboleth.idp.attribute that return IdPAttribute
Modifier and Type
Method
Description
`IdPAttribute`
IdPAttribute.`clone()`
Clones an attribute.
Methods in net.shibboleth.idp.attribute that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Multimap<String,IdPAttribute>`
AttributesMapContainer.`get()`
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`toMapMergeDuplicates(Collection<IdPAttribute> attributes)`
Convert a collection of `IdPAttribute` objects into a mutable `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`toMapNoDuplicates(Collection<IdPAttribute> attributes)`
Convert a collection of `IdPAttribute` objects into a mutable `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`withMapMergeDuplicates(Map<String,IdPAttribute> existingAttributes, Collection<IdPAttribute> newAttributes)`
Add a collection of `IdPAttribute` objects into a mutable input `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`withMapMergeDuplicates(Map<String,IdPAttribute> existingAttributes, Map<String,IdPAttribute> newAttributes)`
Add a collection of `IdPAttribute` objects into a mutable input `Map` keyed by `getId()`.
Methods in net.shibboleth.idp.attribute with parameters of type IdPAttribute
Modifier and Type
Method
Description
`int`
IdPAttribute.`compareTo(IdPAttribute other)`
Method parameters in net.shibboleth.idp.attribute with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`toMapMergeDuplicates(Collection<IdPAttribute> attributes)`
Convert a collection of `IdPAttribute` objects into a mutable `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`toMapNoDuplicates(Collection<IdPAttribute> attributes)`
Convert a collection of `IdPAttribute` objects into a mutable `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`withMapMergeDuplicates(Map<String,IdPAttribute> existingAttributes, Collection<IdPAttribute> newAttributes)`
Add a collection of `IdPAttribute` objects into a mutable input `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`withMapMergeDuplicates(Map<String,IdPAttribute> existingAttributes, Collection<IdPAttribute> newAttributes)`
Add a collection of `IdPAttribute` objects into a mutable input `Map` keyed by `getId()`.
`static Map<String,IdPAttribute>`
IdPAttributeSupport.`withMapMergeDuplicates(Map<String,IdPAttribute> existingAttributes, Map<String,IdPAttribute> newAttributes)`
Add a collection of `IdPAttribute` objects into a mutable input `Map` keyed by `getId()`.
Constructor parameters in net.shibboleth.idp.attribute with type arguments of type IdPAttribute
Modifier
Constructor
Description
``
`AttributesMapContainer(Multimap<String,IdPAttribute> value)`
Constructor.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.config

Methods in net.shibboleth.idp.attribute.config that return IdPAttribute
Modifier and Type
Method
Description
`private IdPAttribute`
AbstractMetadataDrivenConfigurationLookupStrategy.`findMatchingMappedTag(LockableClassToInstanceMultiMap<?> input, String name)`
Find first matching attribute in the input object's node metadata.
`private IdPAttribute`
AbstractMetadataDrivenConfigurationLookupStrategy.`findMatchingMappedTag(EntityDescriptor entity, String name)`
Find first matching attribute in the input object's node metadata.
Methods in net.shibboleth.idp.attribute.config with parameters of type IdPAttribute
Modifier and Type
Method
Description
`protected abstract T`
AbstractMetadataDrivenConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected T`
BeanConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected Boolean`
BooleanConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected Double`
DoubleConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected Duration`
DurationConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected Integer`
IntegerConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected List<T>`
ListConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected Long`
LongConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected Set<T>`
SetConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`protected String`
StringConfigurationLookupStrategy.`doTranslate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.
`private Optional<T>`
AbstractMetadataDrivenConfigurationLookupStrategy.`processMappedTag(IdPAttribute tag, AbstractMetadataDrivenConfigurationLookupStrategy.CachedConfigurationContext cacheContext)`
Process a mapped tag by returning any value found and caching if necessary.
`private T`
AbstractMetadataDrivenConfigurationLookupStrategy.`translate(IdPAttribute tag)`
Translate the value(s) into a setting of the appropriate type.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.context

Fields in net.shibboleth.idp.attribute.context with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private Map<String,IdPAttribute>`
AttributeContext.`attributes`
The attributes tracked by this context.
`private Map<String,IdPAttribute>`
AttributeContext.`unfilteredAttributes`
The attributes tracked by this context prior to filtering.
Methods in net.shibboleth.idp.attribute.context that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
AttributeContext.`getIdPAttributes()`
Gets the map of attributes, indexed by attribute ID, tracked by this context.
`Map<String,IdPAttribute>`
AttributeContext.`getUnfilteredIdPAttributes()`
Gets the map of unfiltered attributes, indexed by attribute ID, tracked by this context.
Method parameters in net.shibboleth.idp.attribute.context with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`AttributeContext`
AttributeContext.`setIdPAttributes(Collection<IdPAttribute> newAttributes)`
Deprecated, for removal: This API element is subject to removal in a future version.
`AttributeContext`
AttributeContext.`setIdPAttributes(Map<String,IdPAttribute> newAttributes)`
Sets the attributes tracked by this context.
`AttributeContext`
AttributeContext.`setUnfilteredIdPAttributes(Collection<IdPAttribute> newAttributes)`
Deprecated, for removal: This API element is subject to removal in a future version.
`AttributeContext`
AttributeContext.`setUnfilteredIdPAttributes(Map<String,IdPAttribute> newAttributes)`
Sets the unfiltered attributes tracked by this context.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter

Methods in net.shibboleth.idp.attribute.filter with parameters of type IdPAttribute
Modifier and Type
Method
Description
`void`
AttributeRule.`apply(IdPAttribute attribute, AttributeFilterContext filterContext)`
Applies this rule to the respective attribute in the filter context.
`Set<IdPAttributeValue>`
Matcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
`Set<IdPAttributeValue>`
MatcherFromPolicy.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter.context

Fields in net.shibboleth.idp.attribute.filter.context with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private Map<String,IdPAttribute>`
AttributeFilterContext.`filteredAttributes`
Attributes which have been filtered.
`private Map<String,IdPAttribute>`
AttributeFilterContext.`prefilteredAttributes`
Attributes which are to be filtered.
Methods in net.shibboleth.idp.attribute.filter.context that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
AttributeFilterContext.`getFilteredIdPAttributes()`
Gets the collection of attributes, indexed by ID, left after the filtering process has run.
`Map<String,IdPAttribute>`
AttributeFilterContext.`getPrefilteredIdPAttributes()`
Gets the collection of attributes that are to be filtered, indexed by attribute ID.
Method parameters in net.shibboleth.idp.attribute.filter.context with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`AttributeFilterContext`
AttributeFilterContext.`setFilteredIdPAttributes(Collection<IdPAttribute> attributes)`
Deprecated, for removal: This API element is subject to removal in a future version.
`AttributeFilterContext`
AttributeFilterContext.`setFilteredIdPAttributes(Map<String,IdPAttribute> attributes)`
Sets the attributes that have been filtered.
`AttributeFilterContext`
AttributeFilterContext.`setPrefilteredIdPAttributes(Collection<IdPAttribute> attributes)`
Deprecated, for removal: This API element is subject to removal in a future version.
`AttributeFilterContext`
AttributeFilterContext.`setPrefilteredIdPAttributes(Map<String,IdPAttribute> attributes)`
Sets the attributes which are to be filtered.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter.matcher.impl

Methods in net.shibboleth.idp.attribute.filter.matcher.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
ScriptedMatcher.MatcherScriptEvaluator.`execute(IdPAttribute attribute, AttributeFilterContext filterContext)`
Execution hook.
`Set<IdPAttributeValue>`
AbstractMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
`Set<IdPAttributeValue>`
ScriptedMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Perform the AttributeValueMatching.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter.matcher.logic.impl

Methods in net.shibboleth.idp.attribute.filter.matcher.logic.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
AndMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
A given attribute value is considered to have matched if, and only if, it is returned by every composed.
`Set<IdPAttributeValue>`
NotMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
A given attribute value is considered to have matched if it is not returned by the composed `Matcher`.
`Set<IdPAttributeValue>`
OrMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter.matcher.saml.impl

Methods in net.shibboleth.idp.attribute.filter.matcher.saml.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`private Multimap<String,IdPAttribute>`
AttributeInMetadataMatcher.`getMappedRequestedAttributes(AttributeConsumingService service)`
Dig into the metadata to determine whether any mapped requested attribute information exists.
Methods in net.shibboleth.idp.attribute.filter.matcher.saml.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`private Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`filterValues(String attributeToLog, IdPAttribute attribute, List<XMLObject> requestedValues)`
Given an attribute and the requested values do the filtering.
`private Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`filterValues(IdPAttribute attribute, List<IdPAttributeValue> requestedValues)`
Given an attribute and the requested values do the filtering.
`Set<IdPAttributeValue>`
AbstractMatchesShibMDScopeMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
`Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter.policyrule.saml.impl

Methods in net.shibboleth.idp.attribute.filter.policyrule.saml.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`private Multimap<String,IdPAttribute>`
AbstractEntityAttributePolicyRule.`getMappedRequestedAttributes(XMLObject metadataObject)`
Dig into the metadata to determine whether any mapped requested attribute information exists.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.filter.testing

Methods in net.shibboleth.idp.attribute.filter.testing with parameters of type IdPAttribute
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
MockMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver

Fields in net.shibboleth.idp.attribute.resolver declared as IdPAttribute
Modifier and Type
Field
Description
`private final IdPAttribute`
ResolvedAttributeDefinition.`resolvedAttribute`
The attribute produced by the resolved attribute definition.
Fields in net.shibboleth.idp.attribute.resolver with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private final Map<String,IdPAttribute>`
ResolvedDataConnector.`resolvedAttributes`
The attributes produced by the resolved data connector.
Methods in net.shibboleth.idp.attribute.resolver that return IdPAttribute
Modifier and Type
Method
Description
`protected abstract IdPAttribute`
AbstractAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
ResolvedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
AbstractAttributeDefinition.`doResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Perform the actual resolution.
`IdPAttribute`
ResolvedAttributeDefinition.`getResolvedAttribute()`
Gets the resolved attribute.
Methods in net.shibboleth.idp.attribute.resolver that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected abstract Map<String,IdPAttribute>`
AbstractDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
ResolvedDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`final Map<String,IdPAttribute>`
AbstractDataConnector.`doResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Perform the actual resolution.
`Map<String,IdPAttribute>`
ResolvedDataConnector.`getResolvedAttributes()`
Gets the resolved attributes.
Methods in net.shibboleth.idp.attribute.resolver with parameters of type IdPAttribute
Modifier and Type
Method
Description
`private static void`
PluginDependencySupport.`addAttribute(IdPAttribute source, Map<String,List<IdPAttributeValue>> target)`
Adds the values of the given attribute to the target collection of attribute values.
`private static void`
PluginDependencySupport.`mergeAttributeValues(IdPAttribute source, List<IdPAttributeValue> target)`
Adds the values of the given attribute to the set of attribute values.
Constructors in net.shibboleth.idp.attribute.resolver with parameters of type IdPAttribute
Modifier
Constructor
Description
``
`ResolvedAttributeDefinition(AttributeDefinition definition, IdPAttribute attribute)`
Constructor.
Constructor parameters in net.shibboleth.idp.attribute.resolver with type arguments of type IdPAttribute
Modifier
Constructor
Description
``
`ResolvedDataConnector(DataConnector connector, Map<String,IdPAttribute> attributes)`
Constructor.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.ad.impl

Fields in net.shibboleth.idp.attribute.resolver.ad.impl declared as IdPAttribute
Modifier and Type
Field
Description
`private final IdPAttribute`
ScriptedIdPAttributeImpl.`encapsulatedAttribute`
The `IdPAttribute` we are encapsulating.
`private IdPAttribute`
StaticAttributeDefinition.`value`
Static value returned by this definition.
Methods in net.shibboleth.idp.attribute.resolver.ad.impl that return IdPAttribute
Modifier and Type
Method
Description
`protected IdPAttribute`
ContextDerivedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
`protected IdPAttribute`
DateTimeAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
DecryptedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
PrescopedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
PrincipalNameAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
`protected IdPAttribute`
RegexSplitAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
ScopedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
ScriptedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
SimpleAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
StaticAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
TemplateAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
ScriptedAttributeDefinition.AttributeDefinitionScriptEvaluator.`execute(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Execution hook.
`IdPAttribute`
ScriptedIdPAttributeImpl.`getNativeAttribute()`
return the underlying attribute.
`protected IdPAttribute`
ScriptedIdPAttributeImpl.`getResultingAttribute()`
Function to reconstruct the attribute after the scripting.
`IdPAttribute`
StaticAttributeDefinition.`getValue()`
Return the static attribute we are returning.
Methods in net.shibboleth.idp.attribute.resolver.ad.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`void`
StaticAttributeDefinition.`setValue(IdPAttribute newAttribute)`
Set the attribute value we are returning.
Constructors in net.shibboleth.idp.attribute.resolver.ad.impl with parameters of type IdPAttribute
Modifier
Constructor
Description
``
`ScriptedIdPAttributeImpl(IdPAttribute attribute, String prefix)`
Constructor.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.ad.mapped.impl

Methods in net.shibboleth.idp.attribute.resolver.ad.mapped.impl that return IdPAttribute
Modifier and Type
Method
Description
`protected IdPAttribute`
MappedAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.context

Fields in net.shibboleth.idp.attribute.resolver.context with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private Map<String,IdPAttribute>`
AttributeResolutionContext.`resolvedAttributes`
Attributes which were resolved and released by the attribute resolver.
Methods in net.shibboleth.idp.attribute.resolver.context that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
AttributeResolutionContext.`getResolvedIdPAttributes()`
Get the collection of resolved attributes.
Methods in net.shibboleth.idp.attribute.resolver.context with parameters of type IdPAttribute
Modifier and Type
Method
Description
`void`
AttributeResolverWorkContext.`recordAttributeDefinitionResolution(AttributeDefinition definition, IdPAttribute attribute)`
Records the results of an attribute definition resolution.
Method parameters in net.shibboleth.idp.attribute.resolver.context with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`void`
AttributeResolverWorkContext.`recordDataConnectorResolution(DataConnector connector, Map<String,IdPAttribute> attributes)`
Records the results of an data connector resolution.
`AttributeResolutionContext`
AttributeResolutionContext.`setResolvedIdPAttributes(Collection<IdPAttribute> attributes)`
Set the set of resolved attributes.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc

Methods in net.shibboleth.idp.attribute.resolver.dc that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
MappingStrategy.`map(T results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.http

Methods in net.shibboleth.idp.attribute.resolver.dc.http that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
HTTPSearch.`execute(org.apache.hc.client5.http.classic.HttpClient client, HttpClientSecurityParameters securityParameters, HTTPResponseMappingStrategy mappingStrategy)`
The abstraction that will contact the service and obtain results.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.http.impl

Methods in net.shibboleth.idp.attribute.resolver.dc.http.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
ScriptedResponseMappingStrategy.`handleResponse(org.apache.hc.core5.http.ClassicHttpResponse response)`
`Map<String,IdPAttribute>`
ScriptedResponseMappingStrategy.`map(Map<String,IdPAttribute> results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.
`protected Map<String,IdPAttribute>`
HTTPDataConnector.`retrieveAttributes(HTTPSearch executable)`
Attempts to retrieve attributes from the data source.
Methods in net.shibboleth.idp.attribute.resolver.dc.http.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`private void`
ScriptedResponseMappingStrategy.`checkValues(IdPAttribute attribute)`
Ensure that all the values in the attribute are of the correct type.
Method parameters in net.shibboleth.idp.attribute.resolver.dc.http.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
ScriptedResponseMappingStrategy.`map(Map<String,IdPAttribute> results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.impl

Fields in net.shibboleth.idp.attribute.resolver.dc.impl with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private Map<String,IdPAttribute>`
StaticDataConnector.`attributes`
Static collection of values returned by this connector.
`private Function<ProfileRequestContext,List<IdPAttribute>>`
ContextDerivedDataConnector.`attributesFunction`
Function used to generate the attributes derived from the `ProfileRequestContext`.
`private Cache<String,Map<String,IdPAttribute>>`
AbstractSearchDataConnector.`resultsCache`
Query result cache.
Methods in net.shibboleth.idp.attribute.resolver.dc.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
AbstractSearchDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
ContextDerivedDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
PairwiseIdDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
StaticDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
PairwiseIdDataConnector.`encodeAsAttribute(String value)`
Encode the provided string.
`Map<String,IdPAttribute>`
StaticDataConnector.`getAttributes()`
Get the static values returned by this connector.
`Function<ProfileRequestContext,List<IdPAttribute>>`
ContextDerivedDataConnector.`getAttributesFunction()`
Gets the attribute derivation function.
`Cache<String,Map<String,IdPAttribute>>`
AbstractSearchDataConnector.`getResultsCache()`
Gets the cache used to cache search results.
`protected abstract Map<String,IdPAttribute>`
AbstractSearchDataConnector.`retrieveAttributes(T1 executable)`
Attempts to retrieve attributes from the data source.
`protected Map<String,IdPAttribute>`
AbstractSearchDataConnector.`retrieveAttributes(T1 executable, AttributeResolverWorkContext workContext)`
A version of `AbstractSearchDataConnector.retrieveAttributes(ExecutableSearch)` that also gets passed the work context.
Method parameters in net.shibboleth.idp.attribute.resolver.dc.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`void`
ContextDerivedDataConnector.`setAttributesFunction(Function<ProfileRequestContext,List<IdPAttribute>> function)`
Sets the attribute derivation function.
`void`
AbstractSearchDataConnector.`setResultsCache(Cache<String,Map<String,IdPAttribute>> cache)`
Sets the cache used to cache search results.
`void`
StaticDataConnector.`setValues(Collection<IdPAttribute> newValues)`
Set static values returned by this connector.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.impl.testing

Methods in net.shibboleth.idp.attribute.resolver.dc.impl.testing that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
SAMLAttributeDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.ldap

Methods in net.shibboleth.idp.attribute.resolver.dc.ldap that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
StringAttributeValueMappingStrategy.`map(SearchResponse results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.ldap.impl

Methods in net.shibboleth.idp.attribute.resolver.dc.ldap.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
LDAPDataConnector.`retrieveAttributes(ExecutableSearchFilter filter)`
Attempts to retrieve attributes from the LDAP.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.rdbms

Methods in net.shibboleth.idp.attribute.resolver.dc.rdbms that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
StringResultMappingStrategy.`map(ResultSet results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.rdbms.impl

Methods in net.shibboleth.idp.attribute.resolver.dc.rdbms.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
RDBMSDataConnector.`retrieveAttributes(ExecutableStatement statement)`
Attempts to retrieve the attribute from the database.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.saml.impl

Methods in net.shibboleth.idp.attribute.resolver.dc.saml.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
SimpleAggregationSAMLDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`private Collection<IdPAttribute>`
BasicResponseMappingStrategy.`filterAssertionResults(List<IdPAttribute> assertionResults, String assertionIssuerID, ProfileRequestContext profileContext, ResponseData responseData)`
Filter the decoded attributes from an Assertion.
`Map<String,IdPAttribute>`
BasicResponseMappingStrategy.`map(ResponseData responseData)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.
`private Collection<IdPAttribute>`
BasicResponseMappingStrategy.`processAssertionFiltering(Assertion assertion, List<IdPAttribute> assertionResults, String assertionIssuerID, ProfileRequestContext profileContext, ResponseData responseData)`
Process filtering the attributes of an Assertion.
`protected Map<String,IdPAttribute>`
SAMLDataConnector.`retrieveAttributes(ExecutableQuery executable)`
Attempts to retrieve attributes from the data source.
`private List<IdPAttribute>`
BasicResponseMappingStrategy.`transcodeAttribute(Attribute samlAttribute, ProfileRequestContext profileContext)`
Transcode a specified `Attribute` into a list of `IdPAttribute`.
Method parameters in net.shibboleth.idp.attribute.resolver.dc.saml.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`private Collection<IdPAttribute>`
BasicResponseMappingStrategy.`filterAssertionResults(List<IdPAttribute> assertionResults, String assertionIssuerID, ProfileRequestContext profileContext, ResponseData responseData)`
Filter the decoded attributes from an Assertion.
`private void`
BasicResponseMappingStrategy.`populateFilterContext(AttributeFilterContext filterContext, Map<String,IdPAttribute> unfilteredAttributes, String assertionIssuer, ResponseData responseData)`
Populate the `AttributeFilterContext` for processing.
`private Collection<IdPAttribute>`
BasicResponseMappingStrategy.`processAssertionFiltering(Assertion assertion, List<IdPAttribute> assertionResults, String assertionIssuerID, ProfileRequestContext profileContext, ResponseData responseData)`
Process filtering the attributes of an Assertion.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.scripted.impl

Methods in net.shibboleth.idp.attribute.resolver.dc.scripted.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
ScriptedDataConnector.DataConnectorScriptEvaluator.`execute(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Execution hook.
`Map<String,IdPAttribute>`
ScriptedMappingStrategy.`map(Map<String,IdPAttribute> results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.
`protected Map<String,IdPAttribute>`
ScriptedDataConnector.`retrieveAttributes(ScriptedSearch executable)`
Attempts to retrieve attributes from the data source.
`protected Map<String,IdPAttribute>`
ScriptedDataConnector.`retrieveAttributes(ScriptedSearch executable, AttributeResolverWorkContext workContext)`
A version of `AbstractSearchDataConnector.retrieveAttributes(ExecutableSearch)` that also gets passed the work context.
Methods in net.shibboleth.idp.attribute.resolver.dc.scripted.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`private void`
ScriptedDataConnector.DataConnectorScriptEvaluator.`checkValues(IdPAttribute attribute)`
Ensure that all the values in the attribute are of the correct type.
Method parameters in net.shibboleth.idp.attribute.resolver.dc.scripted.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
ScriptedMappingStrategy.`map(Map<String,IdPAttribute> results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.dc.storage.impl

Methods in net.shibboleth.idp.attribute.resolver.dc.storage.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`Map<String,IdPAttribute>`
ScriptedStorageMappingStrategy.`map(StorageRecord<?> results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.
`Map<String,IdPAttribute>`
SimpleStorageMappingStrategy.`map(StorageRecord<?> results)`
Maps the given results to a collection of `IdPAttribute` indexed by the attribute's ID.
`protected Map<String,IdPAttribute>`
StorageServiceDataConnector.`retrieveAttributes(StorageServiceSearch executable)`
Attempts to retrieve attributes from the data source.
Methods in net.shibboleth.idp.attribute.resolver.dc.storage.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`private void`
ScriptedStorageMappingStrategy.`checkValues(IdPAttribute attribute)`
Ensure that all the values in the attribute are of the correct type.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.impl

Method parameters in net.shibboleth.idp.attribute.resolver.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`private void`
AttributeResolverImpl.`collectExportingDataConnectors(Map<String,IdPAttribute> resolvedAttributes, AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Helper function to collect attributes and their data & metadata from suitable data connectors.
`private void`
AttributeResolverImpl.`collectResolvedAttributes(Map<String,IdPAttribute> resolvedAttributes, AttributeResolverWorkContext workContext, boolean includeDependencyOnly)`
Helper function to collect suitably resolved attributes.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.scripted

Methods in net.shibboleth.idp.attribute.resolver.scripted that return IdPAttribute
Modifier and Type
Method
Description
`IdPAttribute`
ScriptedIdPAttribute.`getNativeAttribute()`
return the underlying attribute.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.spring.dc.impl

Methods in net.shibboleth.idp.attribute.resolver.spring.dc.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`static Cache<String,Map<String,IdPAttribute>>`
CacheConfigParser.`buildCacheAccess(String timeToLive, String maximumSize)`
Factory method to leverage spring property replacement functionality.
`static Cache<String,Map<String,IdPAttribute>>`
CacheConfigParser.`buildCacheWrite(String timeToLive, String maximumSize)`
Factory method to leverage spring property replacement functionality.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.resolver.testing

Fields in net.shibboleth.idp.attribute.resolver.testing declared as IdPAttribute
Modifier and Type
Field
Description
`private IdPAttribute`
MockAttributeDefinition.`staticValue`
Static value returned by this definition.
`private IdPAttribute`
MockStaticAttributeDefinition.`value`
Static value returned by this definition.
`private IdPAttribute`
TestSources.StaticAttributeDefinition.`value`
Static value returned by this definition.
Fields in net.shibboleth.idp.attribute.resolver.testing with type parameters of type IdPAttribute
Modifier and Type
Field
Description
`private Map<String,IdPAttribute>`
MockStaticDataConnector.`attributes`
Static collection of values returned by this connector.
`private Map<String,IdPAttribute>`
TestSources.StaticDataConnector.`attributes`
Static collection of values returned by this connector.
`private final Map<String,IdPAttribute>`
MockDataConnector.`values`
Static collection of values returned by this connector.
Methods in net.shibboleth.idp.attribute.resolver.testing that return IdPAttribute
Modifier and Type
Method
Description
`static IdPAttribute`
ResolverTestSupport.`buildAttribute(String attributeId, String... values)`
Construct a test `IdPAttribute`
`protected IdPAttribute`
MockAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
MockStaticAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
TestSources.StaticAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Creates and populates the values for the resolved attribute.
`IdPAttribute`
MockStaticAttributeDefinition.`getValue()`
Return the static attribute we are returning.
`IdPAttribute`
TestSources.StaticAttributeDefinition.`getValue()`
Return the static attribute we are returning.
Methods in net.shibboleth.idp.attribute.resolver.testing that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
MockDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
MockStaticDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`protected Map<String,IdPAttribute>`
TestSources.StaticDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
`Map<String,IdPAttribute>`
MockStaticDataConnector.`getAttributes()`
Get the static values returned by this connector.
`Map<String,IdPAttribute>`
TestSources.StaticDataConnector.`getAttributes()`
Get the static values returned by this connector.
Methods in net.shibboleth.idp.attribute.resolver.testing with parameters of type IdPAttribute
Modifier and Type
Method
Description
`static MockStaticDataConnector`
ResolverTestSupport.`buildDataConnector(String connectorId, IdPAttribute... attributes)`
Construct a test `DataConnector`
`static AttributeDefinition`
TestSources.`populatedStaticAttribute(IdPAttribute attribute)`
Create a static attribute with known attribute.
`void`
MockStaticAttributeDefinition.`setValue(IdPAttribute newAttribute)`
Set the attribute value we are returning.
`void`
TestSources.StaticAttributeDefinition.`setValue(IdPAttribute newAttribute)`
Set the attribute value we are returning.
Method parameters in net.shibboleth.idp.attribute.resolver.testing with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`static DataConnector`
TestSources.`populatedStaticConnector(List<IdPAttribute> attributes)`
Create a static connector with provided attributes and values.
`void`
MockStaticDataConnector.`setValues(Collection<IdPAttribute> newValues)`
Set static values returned by this connector.
`void`
TestSources.StaticDataConnector.`setValues(Collection<IdPAttribute> newValues)`
Set static values returned by this connector.
Constructors in net.shibboleth.idp.attribute.resolver.testing with parameters of type IdPAttribute
Modifier
Constructor
Description
``
`MockAttributeDefinition(String id, IdPAttribute value)`
Constructor.
Constructor parameters in net.shibboleth.idp.attribute.resolver.testing with type arguments of type IdPAttribute
Modifier
Constructor
Description
``
`MockDataConnector(String id, Map<String,IdPAttribute> connectorValues)`
Constructor.
``
`MockDataConnector(String id, Map<String,IdPAttribute> connectorValues, Set<ResolverAttributeDefinitionDependency> attrDepends, Set<ResolverDataConnectorDependency> dcDepends)`
Constructor.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.transcoding

Methods in net.shibboleth.idp.attribute.transcoding that return IdPAttribute
Modifier and Type
Method
Description
`IdPAttribute`
AbstractAttributeTranscoder.`decode(ProfileRequestContext profileRequestContext, T input, TranscodingRule rule)`
Decode the supplied object into a protocol-neutral representation.
`IdPAttribute`
AttributeTranscoder.`decode(ProfileRequestContext profileRequestContext, T input, TranscodingRule rule)`
Decode the supplied object into a protocol-neutral representation.
`protected abstract IdPAttribute`
AbstractAttributeTranscoder.`doDecode(ProfileRequestContext profileRequestContext, T input, TranscodingRule rule)`
Decode the supplied object into a protocol-neutral representation.
Methods in net.shibboleth.idp.attribute.transcoding with parameters of type IdPAttribute
Modifier and Type
Method
Description
`protected abstract T`
AbstractAttributeTranscoder.`doEncode(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends T> to, TranscodingRule rule)`
Encode the supplied attribute into a protocol specific representation.
`T`
AbstractAttributeTranscoder.`encode(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends T> to, TranscodingRule rule)`
Encode the supplied attribute into a protocol specific representation.
`T`
AttributeTranscoder.`encode(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends T> to, TranscodingRule rule)`
Encode the supplied attribute into a protocol specific representation.
`Map<Locale,String>`
AttributeTranscoderRegistry.`getDescriptions(IdPAttribute attribute)`
Get the localized descriptions for an `IdPAttribute`.
`Map<Locale,String>`
AttributeTranscoderRegistry.`getDisplayNames(IdPAttribute attribute)`
Get the localized display names for an `IdPAttribute`.
`Collection<TranscodingRule>`
AttributeTranscoderRegistry.`getTranscodingRules(IdPAttribute from, Class<?> to)`
Obtains a set of instructions for encoding an input `IdPAttribute` into a target type.

## Uses of IdPAttribute in net.shibboleth.idp.attribute.transcoding.impl

Methods in net.shibboleth.idp.attribute.transcoding.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`Map<Locale,String>`
AttributeTranscoderRegistryImpl.`getDescriptions(IdPAttribute attribute)`
Get the localized descriptions for an `IdPAttribute`.
`Map<Locale,String>`
AttributeTranscoderRegistryImpl.`getDisplayNames(IdPAttribute attribute)`
Get the localized display names for an `IdPAttribute`.
`Collection<TranscodingRule>`
AttributeTranscoderRegistryImpl.`getTranscodingRules(IdPAttribute from, Class<?> to)`
Obtains a set of instructions for encoding an input `IdPAttribute` into a target type.

## Uses of IdPAttribute in net.shibboleth.idp.saml.attribute.impl

Method parameters in net.shibboleth.idp.saml.attribute.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`private <T> void`
AttributeMappingNodeProcessor.`decodeAttribute(Collection<TranscodingRule> rules, T input, Multimap<String,IdPAttribute> results)`
Access the registry of transcoding rules to decode the input object.

## Uses of IdPAttribute in net.shibboleth.idp.saml.attribute.resolver.impl

Methods in net.shibboleth.idp.saml.attribute.resolver.impl that return IdPAttribute
Modifier and Type
Method
Description
`protected IdPAttribute`
SAML1NameIdentifierAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Deprecated, for removal: This API element is subject to removal in a future version.
Creates and populates the values for the resolved attribute.
`protected IdPAttribute`
SAML2NameIDAttributeDefinition.`doAttributeDefinitionResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Deprecated, for removal: This API element is subject to removal in a future version.
Creates and populates the values for the resolved attribute.
Methods in net.shibboleth.idp.saml.attribute.resolver.impl that return types with arguments of type IdPAttribute
Modifier and Type
Method
Description
`protected Map<String,IdPAttribute>`
EntityAttributesDataConnector.`doDataConnectorResolve(AttributeResolutionContext resolutionContext, AttributeResolverWorkContext workContext)`
Retrieves a collection of attributes from some data source.
Method parameters in net.shibboleth.idp.saml.attribute.resolver.impl with type arguments of type IdPAttribute
Modifier and Type
Method
Description
`private void`
EntityAttributesDataConnector.`resolveMappedTags(XMLObject parent, Map<String,IdPAttribute> results)`
Pull in mapped tags as resolved attributes.

## Uses of IdPAttribute in net.shibboleth.idp.saml.attribute.transcoding

Methods in net.shibboleth.idp.saml.attribute.transcoding that return IdPAttribute
Modifier and Type
Method
Description
`protected IdPAttribute`
AbstractSAML1AttributeTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, AttributeDesignator attribute, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.
`protected IdPAttribute`
AbstractSAML2AttributeTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.
`protected abstract IdPAttribute`
AbstractSAMLAttributeTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, AttributeType attribute, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.
`IdPAttribute`
AbstractSAMLAttributeTranscoder.`doDecode(ProfileRequestContext profileRequestContext, AttributeType input, TranscodingRule rule)`
Decode the supplied object into a protocol-neutral representation.
Methods in net.shibboleth.idp.saml.attribute.transcoding with parameters of type IdPAttribute
Modifier and Type
Method
Description
`protected AttributeDesignator`
AbstractSAML1AttributeTranscoder.`buildAttribute(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends AttributeDesignator> to, TranscodingRule rule, List<XMLObject> attributeValues)`
Builds a SAML attribute element from the given attribute values.
`protected Attribute`
AbstractSAML2AttributeTranscoder.`buildAttribute(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends Attribute> to, TranscodingRule rule, List<XMLObject> attributeValues)`
Builds a SAML attribute element from the given attribute values.
`protected abstract AttributeType`
AbstractSAMLAttributeTranscoder.`buildAttribute(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends AttributeType> to, TranscodingRule rule, List<XMLObject> attributeValues)`
Builds a SAML attribute element from the given attribute values.
`protected abstract boolean`
AbstractSAMLAttributeTranscoder.`canEncodeValue(IdPAttribute idpAttribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`AttributeType`
AbstractSAMLAttributeTranscoder.`doEncode(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends AttributeType> to, TranscodingRule rule)`
Encode the supplied attribute into a protocol specific representation.
`static XMLObject`
SAMLEncoderSupport.`encodeByteArrayValue(IdPAttribute attribute, QName attributeValueElementName, byte[] value, boolean withType)`
Base64 encodes a `byte[]` into a SAML attribute value element.
`static XMLObject`
SAMLEncoderSupport.`encodeDateTimeValue(IdPAttribute attribute, QName attributeValueElementName, Instant value, boolean withType)`
Encodes a date/time value into a SAML attribute value element.
`protected void`
AbstractSAML1AttributeTranscoder.`encodeName(ProfileRequestContext profileRequestContext, IdPAttribute attribute, AttributeDesignator samlAttribute, TranscodingRule rule)`
`protected void`
AbstractSAML2AttributeTranscoder.`encodeName(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Attribute samlAttribute, TranscodingRule rule)`
`static XMLObject`
SAMLEncoderSupport.`encodeScopedStringValueAttribute(IdPAttribute attribute, QName attributeValueElementName, ScopedStringAttributeValue value, String scopeAttributeName, boolean withType)`
Encode a `ScopedStringAttributeValue` value in to an SAML attribute value element using the (older Shibboleth) sytnax where the scope is inside an XML attribute.
`static XMLObject`
SAMLEncoderSupport.`encodeScopedStringValueInline(IdPAttribute attribute, QName attributeValueElementName, ScopedStringAttributeValue value, String scopeDelimiter, boolean withType)`
Encode a `ScopedStringAttributeValue` value into a SAML attribute value element using the "inline" syntax where the scope and value are combined into a string.
`static XMLObject`
SAMLEncoderSupport.`encodeStringValue(IdPAttribute attribute, QName attributeValueElementName, String value, boolean withType)`
Encodes a String value into a SAML attribute value element.
`protected abstract XMLObject`
AbstractSAMLAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, EncodedType value)`
Encodes an attribute value into a SAML AttributeValue element.
`static XMLObject`
SAMLEncoderSupport.`encodeXMLObjectValue(IdPAttribute attribute, QName attributeValueElementName, XMLObject value)`
Encodes an `XMLObject` value in to a `XSAny` SAML attribute value.

## Uses of IdPAttribute in net.shibboleth.idp.saml.attribute.transcoding.impl

Methods in net.shibboleth.idp.saml.attribute.transcoding.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`protected boolean`
SAML1ByteAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML1ScopedStringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML1StringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML1XMLObjectAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2ByteAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2DateTimeAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2ScopedStringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2StringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2XMLObjectAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected XMLObject`
SAML1ByteAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, ByteAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML1ScopedStringAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, ScopedStringAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML1StringAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, StringAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML1XMLObjectAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, XMLObjectAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML2ByteAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, ByteAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML2DateTimeAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, DateTimeAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML2ScopedStringAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, ScopedStringAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML2StringAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, StringAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML2XMLObjectAttributeTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, XMLObjectAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.

## Uses of IdPAttribute in net.shibboleth.idp.saml.saml2.nameid.transcoding

Methods in net.shibboleth.idp.saml.saml2.nameid.transcoding that return IdPAttribute
Modifier and Type
Method
Description
`protected IdPAttribute`
AbstractSAML2NameIDTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, NameID nameID, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.
Methods in net.shibboleth.idp.saml.saml2.nameid.transcoding with parameters of type IdPAttribute
Modifier and Type
Method
Description
`protected NameID`
AbstractSAML2NameIDTranscoder.`buildAttribute(ProfileRequestContext profileRequestContext, IdPAttribute attribute, Class<? extends NameID> to, TranscodingRule rule, List<XMLObject> attributeValues)`
Builds a SAML attribute element from the given attribute values.

## Uses of IdPAttribute in net.shibboleth.idp.saml.saml2.nameid.transcoding.impl

Methods in net.shibboleth.idp.saml.saml2.nameid.transcoding.impl with parameters of type IdPAttribute
Modifier and Type
Method
Description
`protected boolean`
SAML2ScopedStringNameIDTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2StringNameIDTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected XMLObject`
SAML2ScopedStringNameIDTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, ScopedStringAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.
`protected XMLObject`
SAML2StringNameIDTranscoder.`encodeValue(ProfileRequestContext profileRequestContext, IdPAttribute attribute, TranscodingRule rule, StringAttributeValue value)`
Encodes an attribute value into a SAML AttributeValue element.